package com.fp.persistence.pgeneral.safe;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que hace referencia a la Clave Primaria de TSAFEUSERSESSIONLOG*/
@Embeddable
public class TsafeUserSessionLogKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="WORKINGDATE", nullable=false,updatable=false)

/**
* Fecha de trabajo del sistema
*/
private Date workingdate;

@Column(name="SEQUENCE", nullable=false,updatable=false)

/**
* Secuencia de la tabla
*/
private Integer sequence;

@Column(name="COMPANYCODE", nullable=false,updatable=false)

/**
* Codigo de compania donde se realiza el inicio de sesion
*/
private Integer companycode;

/**Contructor por defecto*/
public TsafeUserSessionLogKey(){}
/**Contructor de TsafeUserSessionLogKey
@param pWorkingdate Fecha de trabajo del sistema
@param pSequence Secuencia de la tabla
@param pCompanycode Codigo de compania donde se realiza el inicio de sesion
*/
public TsafeUserSessionLogKey(Date pWorkingdate,Integer pSequence,Integer pCompanycode){
 workingdate=pWorkingdate;
 sequence=pSequence;
 companycode=pCompanycode;
}
/**Obtiene el valor de workingdate
@return valor de workingdate*/
public Date getWorkingdate(){
  return workingdate;
}
/**Fija el valor de workingdate
@param pWorkingdate nuevo Valor de workingdate*/
public void setWorkingdate(Date pWorkingdate){
  workingdate=pWorkingdate;
}

/**Obtiene el valor de sequence
@return valor de sequence*/
public Integer getSequence(){
  return sequence;
}
/**Fija el valor de sequence
@param pSequence nuevo Valor de sequence*/
public void setSequence(Integer pSequence){
  sequence=pSequence;
}

/**Obtiene el valor de companycode
@return valor de companycode*/
public Integer getCompanycode(){
  return companycode;
}
/**Fija el valor de companycode
@param pCompanycode nuevo Valor de companycode*/
public void setCompanycode(Integer pCompanycode){
  companycode=pCompanycode;
}

/**Implementacion de la comparacion de TsafeUserSessionLogKey
@param o Objeto de comparacion
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TsafeUserSessionLogKey))return false;
  TsafeUserSessionLogKey that = (TsafeUserSessionLogKey) o;
  if (this.getWorkingdate() == null || that.getWorkingdate() == null){
      return false;
  }
  if (! this.getWorkingdate().equals(that.getWorkingdate())){
    return false;
  }
  if (this.getSequence() == null || that.getSequence() == null){
      return false;
  }
  if (! this.getSequence().equals(that.getSequence())){
    return false;
  }
  if (this.getCompanycode() == null || that.getCompanycode() == null){
      return false;
  }
  if (! this.getCompanycode().equals(that.getCompanycode())){
    return false;
  }
  return true;
}
/**Implementacion del metodo hashCode bajo el patron de Bloch
@return hashCode de la instancia TsafeUserSessionLogKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getWorkingdate() == null ? 0 : this.getWorkingdate().hashCode());
    result = result * 37 + (this.getSequence() == null ? 0 : this.getSequence().hashCode());
    result = result * 37 + (this.getCompanycode() == null ? 0 : this.getCompanycode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
